// static/nativeComponents/AreaNavigation/index.js
const app = getApp()
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    datas : {
      type : Object
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    noShow : false,
    positionCity: "",
    changeShow: false,
    positionName: '定位中',
    wxReady: false
  },
  ready(){
    console.log('++++++++++++++++++++定位组件加载好了++++++++++++++++++++')
    console.log(getCurrentPages())
    
    if (this.data.datas.componentInfo.visible == 1) {
      let _this = this;

      if (wx.getStorageSync('location')) {
        this.setData({
          'datas.componentData.designateAreaObj': JSON.parse(wx.getStorageSync('location'))
        })
        this.setData({
          positionName: this.data.datas.componentData.designateAreaObj.regionName
        })
      }

      

      wx.getLocation({
        type: 'wgs84',
        success(res) {
          console.log(res, '++++++++++获取地区')
          const latitude = res.latitude
          const longitude = res.longitude

          wx.request({
            url: `http://test-m-shop.mayi888.cn/test/innerApi/shopApiService/operatingArea/query_Location_operating_area_area_list?location=${longitude},${latitude}`,
            header: {
              'Shop-Mixid': 'Id9uwD'
            },
            success(data) {
              if (data.data.code == '200') {
                let city = ''
                data.data.data.forEach(item => {
                  if (item.operatingAreaAreaId) {
                    city = item;
                  }
                })
                if (city == '') {
                  _this.setData({
                    positionCity: data.data.data[0]
                  })
                } else {
                  _this.setData({
                    positionCity: city
                  })
                }

                console.log(_this.data.positionCity, '定位城市信息')
                console.log(_this.data.datas.componentData.designateAreaObj,'组件信息')
                let str = JSON.stringify({
                  id: _this.data.positionCity.operatingAreaAreaId,
                  regionName: _this.data.positionCity.regionName,
                  regionType: _this.data.positionCity.regionType,
                  systemRegionId: _this.data.positionCity.systemRegionId,
                  outId: _this.data.positionCity.outId,
                  areaGroupId: _this.data.positionCity.areaGroupId,
                })
                console.log(str,'str.......')
                wx.setStorageSync('location', str)

                if (_this.data.positionCity.operatingAreaAreaId == _this.data.datas.componentData.designateAreaObj.id){
                  _this.setData({
                    positionName: _this.data.positionCity.regionName
                  })
                }else{
                  _this.setData({
                    changeShow : true
                  })
                }

                

              } else {

              }
            }
          })

        },
        fail(error) {
          console.log('定位失败')
        }
      })
    }


    console.log('++++++++++++++++++++定位组件加载好了++++++++++++++++++++')
  },
  
  pageLifetimes : {
    show(){
      console.log('组件页面出来show', this.data.datas.componentData.designateAreaObj)
      console.log('组件页面出来show', this.data.positionCity)

      if(wx.getStorageSync('location')){
        let locationObj = JSON.parse(wx.getStorageSync('location'))
        if (locationObj.id){
          if (locationObj.id != this.data.positionCity.operatingAreaAreaId){
            this.setData({
              positionName: locationObj.regionName
            })

            this.setData({
              'datas.componentData.designateAreaObj.id': locationObj.id,
              'datas.componentData.designateAreaObj.regionName': locationObj.regionName,
              'datas.componentData.designateAreaObj.regionType': locationObj.regionType,
              'datas.componentData.designateAreaObj.systemRegionId': locationObj.systemRegionId,
              'datas.componentData.designateAreaObj.areaGroupId': locationObj.areaGroupId,
              'datas.componentData.designateAreaObj.outId': locationObj.outId
            })

            let obj = {
              operatingAreaAreaId: locationObj.id,
              regionName: locationObj.regionName,
              regionType: locationObj.regionType,
              systemRegionId: locationObj.systemRegionId,
              areaGroupId: locationObj.areaGroupId,
              outId: locationObj.outId,
            }

            this.setData({
              positionCity : obj
            })
          }
          return
        }

        if (locationObj.regionName != this.data.positionCity.regionName){
          this.setData({
            positionName: locationObj.regionName
          })
          this.setData({
            'datas.componentData.designateAreaObj.id': locationObj.id,
            'datas.componentData.designateAreaObj.regionName': locationObj.regionName,
            'datas.componentData.designateAreaObj.regionType': locationObj.regionType,
            'datas.componentData.designateAreaObj.systemRegionId': locationObj.systemRegionId,
            'datas.componentData.designateAreaObj.areaGroupId': locationObj.areaGroupId,
            'datas.componentData.designateAreaObj.outId': locationObj.outId
          })
          let obj = {
            operatingAreaAreaId: locationObj.id,
            regionName: locationObj.regionName,
            regionType: locationObj.regionType,
            systemRegionId: locationObj.systemRegionId,
            areaGroupId: locationObj.areaGroupId,
            outId: locationObj.outId,
          }

          this.setData({
            positionCity: obj
          })
          return
        }
      }

      
    }
  },


  /**
   * 组件的方法列表
   */
  methods: {
    //切换城市
    changeTo(){
      
      this.setData({
        'datas.componentData.designateAreaObj.id': this.data.positionCity.operatingAreaAreaId,
        'datas.componentData.designateAreaObj.regionName': this.data.positionCity.regionName,
        'datas.componentData.designateAreaObj.regionType': this.data.positionCity.regionType,
        'datas.componentData.designateAreaObj.systemRegionId': this.data.positionCity.systemRegionId,
        'datas.componentData.designateAreaObj.areaGroupId': this.data.positionCity.areaGroupId,
        'datas.componentData.designateAreaObj.outId': this.data.positionCity.outId
      })

      console.log(this.data.datas.componentData.designateAreaObj)
      console.log(this.data.positionCity)
      let change = JSON.stringify(this.data.datas.componentData.designateAreaObj)
      this.setData({
        positionName: this.data.positionCity.regionName,
        changeShow : false
      })
      wx.setStorageSync('location', change )
      // wx.startPullDownRefresh()
    },
    continueBrowser(){
      console.log(this.data.datas.componentData.designateAreaObj)
      wx.setStorageSync('location', JSON.stringify(this.data.datas.componentData.designateAreaObj))
      this.setData({
        positionName: this.data.datas.componentData.designateAreaObj.regionName,
        changeShow: false
      })
      // wx.startPullDownRefresh()

    },
    changeOtherCity(){
      console.log(getCurrentPages())
      wx.navigateTo({
        url: '/pages/changeAdr/main?areaGroupId=' + this.data.datas.componentData.areaGroupId,
      })
    }
  },
  
})
